<?php

namespace App\Dto\Input;

use App\Dto\Output\OrganizationalUnitOutput;
use App\Entity\Client;
use Symfony\Component\Serializer\Annotation\Groups;
use Symfony\Component\Validator\Constraints as Assert;

final class ChangeOrganizationalUnitInput
{
    /**
     * @var Client[]
     */
    #[Assert\GreaterThan(1)]
    #[Groups(['user-group:write'])]
    public ?array $clients = [];

    #[Assert\NotNull]
    #[Groups(['user-group:write'])]
    public ?OrganizationalUnitOutput $organizationalUnit = null;
}