<?php

namespace App\Dto\Output;

use ApiPlatform\Metadata\Get;
use App\Entity\OperativeSystem;
use Symfony\Component\Serializer\Annotation\Groups;

#[Get(shortName: 'OperativeSystem')]
final class OperativeSystemOutput extends AbstractOutput
{
    #[Groups(['operative-system:read', 'partition:read'])]
    public string $name;

    public function __construct(OperativeSystem $operativeSystem)
    {
        parent::__construct($operativeSystem);

        $this->name = $operativeSystem->getName();
    }
}